<!-- 合格供方名录列表 -->
<script name="SupplierList" lang="ts" setup>
import type { DateModelType } from 'element-plus'
import dayjs from 'dayjs'
import { ElMessage, ElMessageBox } from 'element-plus'
import type { IDictType, IListQuery, ISupplierInfo } from './supplier-interface'
import SupplierApprovalDialog from './supplierApprovalDialog.vue'
import type { IMenu } from '@/components/buttonBox/buttonBox'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { getDictByCode } from '@/api/system/dict'
import { draftDelete, getSupplierInfoList } from '@/api/resource/supplier'

// 定义常量
const buttonBoxActive = 'supplierInfoApproval' // 存储在sessionstorage里面的字段名，用于记录右上角buttonbox点击状态
const flowFormId = 'zyglhggfml' // 资源管理-合格供方名录

const { proxy } = getCurrentInstance() as any
const router = useRouter()

// 选中的审批状态按钮
const active = ref('')
const menu = ref<IMenu[]>([]) // 审批状态按钮组合
const approvalStatusList = ref<String[]>([
  '全部', '已审批', '草稿箱', '待审批', '审批中', '已通过', '未通过', '已取消', '我的审批单',
])

const supplierTypeDict = ref<Array<IDictType>>([])

// 弹窗子组件
const apprDial = ref()

// 查询条件
const searchQuery = ref<IListQuery>({
  supplierNo: '', // 供方编号
  supplierName: '', // 供方名称
  director: '', // 联系人
  supplierType: '', // 供方类型
  createTimeStart: '', // 创建时间-起始
  createTimeEnd: '', // 创建时间-结束
  approvalStatus: active.value, // 审批状态
  formId: flowFormId, // 表单id（流程定义对应的表单id，等价于业务id），此处为固定值
  offset: 1,
  limit: 20,
})
const dateRange = ref<[DateModelType, DateModelType]>(['', ''])// 筛选时间段数据
const total = ref(0) // 数据条数
const loadingTable = ref(false) // 表格loading

// 表头
const columns = ref<TableColumn[]>([
  { text: '供方编号', value: 'supplierNo', align: 'center', width: '175' },
  { text: '供方名称', value: 'supplierName', align: 'center' },
  { text: '供方类型', value: 'supplierTypeName', align: 'center' },
  { text: '联系电话', value: 'phone', align: 'center', width: '120' },
  { text: '服务和供应的内容', value: 'supplierContent', align: 'center', width: '140' },
  { text: '地址', value: 'companyAddress', align: 'center' },
  { text: '创建时间', value: 'createTime', align: 'center', width: '160' },
  { text: '审批状态', value: 'approvalStatusName', align: 'center', width: '100' },
])
const supplierInfoList = ref<Array<ISupplierInfo>>([]) // 表格数据

// 逻辑
// 跳转到新建的页面
const addSupplierInfo = () => {
  router.push({
    query: {
      type: 'create',
    },
    path: '/outsideService/supplierList/detail',
  })
}

// 点击编辑按钮
const updateInfo = (row: ISupplierInfo) => {
  sessionStorage.setItem('supplierInfo', JSON.stringify(row))
  router.push({
    query: {
      type: 'update',
      id: row.id,
      status: searchQuery.value.approvalStatus,
    },
    path: '/outsideService/supplier/detail',
  })
}

// 点击查看（或编辑）按钮
const detail = (row: ISupplierInfo) => {
  if (searchQuery.value.approvalStatus === '1') {
    // 全部或草稿箱 状态的 查看 是可以编辑的组件
    updateInfo(row)
  }
  else {
    // 将行数据存入缓存 用来在路由之间传递数据
    sessionStorage.setItem('supplierInfo', JSON.stringify(row))

    router.push({
      query: {
        type: 'detail',
        id: row.id,
        status: searchQuery.value.approvalStatus,
      },
      path: '/outsideService/info/detail',
    })
  }
}

// 删除供方名录 或 删除草稿箱中的审批单
const deleteById = (row: any) => {
  const confirmStr = `${active.value}` === '0' ? `供方${row.supplierName}` : `供方审批单${row.supplierNo}`
  ElMessageBox.confirm(`是否删除${confirmStr}`, '提示', {
    confirmButtonText: '确认',
    cancelButtonText: '取消',
    type: 'warning',
  }).then(() => {
    draftDelete({ id: row.id }).then((res) => {
      if (res.code === 200) {
        ElMessage.success(`${confirmStr} 删除成功`)
        fetchData()
      }
      else {
        ElMessage.error(`${confirmStr} 删除失败: ${res.message}`)
      }
    })
  })
}

// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    searchQuery.value.offset = 1
  }
  getSupplierInfoList(searchQuery.value).then((response) => {
    if (response.code === 200) {
      supplierInfoList.value = response.data.rows.map((item: { createTime: string }) => {
        return {
          ...item,
          createTime: item.createTime.length > 16 ? item.createTime.substring(0, 16) : '',
        }
      })
      total.value = parseInt(response.data.total)
    }
    loadingTable.value = false
  }).catch(() => {
    loadingTable.value = false
  })
}

const searchList = () => {
  fetchData(true)
}

// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    searchQuery.value.limit = val.size
  }
  if (val && val.page) {
    searchQuery.value.offset = val.page
  }
  fetchData(true)
}

// 重置
const reset = () => {
  searchQuery.value = {
    supplierNo: '', // 供方编号
    supplierName: '', // 供方名称
    director: '', // 联系人
    supplierType: '', // 供方类型
    createTimeStart: '', // 创建时间-起始
    createTimeEnd: '', // 创建时间-结束
    approvalStatus: active.value, // 审批状态
    formId: flowFormId, // 表单id（流程定义对应的表单id，等价于业务id），此处为固定值
    offset: 1,
    limit: 20,
  }
  dateRange.value = ['', '']
  fetchData(true)
}

// 审批按钮点击切换事件
const changeCurrentButton = (val: string) => {
  active.value = val // 此时的tab
  window.sessionStorage.setItem(buttonBoxActive, val) // 记录tab状态

  reset() // 刷新
}

// 流程审批-同意
const approvalAgreeHandler = (row: ISupplierInfo) => {
  apprDial.value.initDialog('agree', row.id, row.taskId, '')
}

// 流程审批-拒绝
const approvalRefuseHandler = (row: ISupplierInfo) => {
  apprDial.value.initDialog('refuse', row.id, row.taskId, '')
}

// 取消（撤回审批单）
const revokeApprById = (row: ISupplierInfo) => {
  apprDial.value.initDialog('revoke', row.id, row.taskId, row.processId)
}

// 流程操作之后刷新
const afterApprovalHandler = () => {
  fetchData(true)
}

// 初始化流程审批状态按钮
const getApprovalStatusDict = () => {
  getDictByCode('approvalStatus').then((res) => {
    if (res.code === 200) {
      res.data.forEach((item: IDictType) => {
        if (approvalStatusList.value.includes(item.name)) {
          menu.value.push({
            name: item.name,
            id: `${item.value}`,
          })
        }
      })
    }
  })
}

// 获取供应商类型字典值
const getSupplierTypeDict = () => {
  getDictByCode('bizSupplierType').then((res) => {
    if (res.code === 200) {
      supplierTypeDict.value = res.data
      sessionStorage.setItem('bizSupplierType', JSON.stringify(supplierTypeDict.value))
    }
  })
}

const getLabCodeDict = async () => {
  await getDictByCode('bizLabCode').then((res) => {
    if (res.code === 200) {
      sessionStorage.setItem('bizLabCode', JSON.stringify(res.data))
    }
  })
}

const getGroupCodeDict = async () => {
  await getDictByCode('bizGroupCode').then((res) => {
    if (res.code === 200) {
      sessionStorage.setItem('bizGroupCode', JSON.stringify(res.data))
    }
  })
}

const getDict = async () => {
  getApprovalStatusDict()
  getSupplierTypeDict()
  getLabCodeDict()
  getGroupCodeDict()
}

watch(dateRange, (val) => {
  if (val) {
    searchQuery.value.createTimeStart = dayjs(val[0]).format('YYYY-MM-DD') === 'Invalid Date' ? '' : dayjs(val[0]).format('YYYY-MM-DD')
    searchQuery.value.createTimeEnd = dayjs(val[1]).format('YYYY-MM-DD') === 'Invalid Date' ? '' : dayjs(val[1]).format('YYYY-MM-DD')
  }
  else {
    searchQuery.value.createTimeStart = ''
    searchQuery.value.createTimeEnd = ''
  }
})

onMounted(async () => {
  await getDict()
  if (sessionStorage.getItem(buttonBoxActive) !== 'undefined' && sessionStorage.getItem(buttonBoxActive) !== null) {
    active.value = sessionStorage.getItem(buttonBoxActive)!
  }
  else {
    active.value = '0' // 全部
  }
})
</script>

<template>
  <app-container>
    <!-- 筛选条件 -->
    <search-area :need-clear="true" @search="searchList" @clear="reset">
      <search-item>
        <el-input v-model="searchQuery.supplierNo" placeholder="供方编号" clearable />
      </search-item>
      <search-item>
        <el-input v-model="searchQuery.supplierName" placeholder="供方名称" clearable />
      </search-item>
      <search-item>
        <el-input v-model="searchQuery.director" placeholder="联系人" clearable />
      </search-item>
      <search-item>
        <el-select v-model="searchQuery.supplierType" placeholder="供方类型" clearable>
          <el-option v-for="item in supplierTypeDict" :key="item.id" :value="item.value" :label="item.name" />
        </el-select>
      </search-item>
      <search-item>
        <el-date-picker v-model="dateRange" type="daterange" start-placeholder="创建时间（开始）" end-placeholder="创建时间（结束）" />
      </search-item>
    </search-area>

    <!-- 表格数据展示 -->
    <table-container>
      <!-- 表头区域 -->
      <template v-if="active === '0'" #btns-right>
        <icon-button icon="icon-add" title="新建" @click="addSupplierInfo" />
      </template>

      <!-- 表格区域 -->
      <normal-table
        id="supplierInfoTabel"
        :data="supplierInfoList" :total="total" :columns="columns"
        :query="{ limit: searchQuery.limit, offset: searchQuery.offset }"
        :list-loading="loadingTable"
        @change="changePage"
      >
        <template #preColumns>
          <el-table-column label="序号" width="55" align="center">
            <template #default="scope">
              {{ (searchQuery.offset - 1) * searchQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
        <template #columns>
          <el-table-column fixed="right" label="操作" align="center" width="130">
            <template #default="{ row }">
              <el-button size="small" type="primary" link @click="detail(row)">
                查看
              </el-button>

              <el-button v-if="active === '0' && proxy.hasPerm(`/resource/customer/infoList/edit`)" size="small" type="primary" link @click="updateInfo(row)">
                编辑
              </el-button>

              <el-button v-if="active === '0' && proxy.hasPerm(`/resource/customer/infoList/del`)" size="small" type="danger" link @click="deleteById(row)">
                删除
              </el-button>
              <el-button v-if="(active === '1' || active === '6') && proxy.hasPerm(`/resource/customer/infoList/delAppr`)" size="small" type="danger" link @click="deleteById(row)">
                删除
              </el-button>

              <template v-if="active === '2'">
                <el-button size="small" type="primary" link @click="approvalAgreeHandler(row)">
                  同意
                </el-button>
                <el-button size="small" type="danger" link @click="approvalRefuseHandler(row)">
                  拒绝
                </el-button>
              </template>
              <template v-if="active === '3'">
                <el-button size="small" type="info" link @click="revokeApprById(row)">
                  取消
                </el-button>
              </template>
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>

    <!-- 审批单弹窗 -->
    <supplier-approval-dialog ref="apprDial" @on-success="afterApprovalHandler" />

    <!-- 右上角按钮集合 -->
    <button-box :active="active" :menu="menu" @change-current-button="changeCurrentButton" />
  </app-container>
</template>
